(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
(*  Soubor: FORMULE.PAS                                                    *)
(*  Obsah: male demo na ukazku funkci jednotky VESA                        *)
(*  Autor: Mircosoft                                                       *)
(*  Posledni uprava: 19.11.2005                                            *)
(*  Pro kompilaci: viz uses                                                *)
(*  Pro spusteni: FORMULE.DAT                                              *)
(*  Upozorneni: tyto zdrojove kody pouzivate na vlastni nebezpeci          *)
(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
{$I+}
program Desert_Rider;
{Napsano jen kvuli tomu, abych si vyzkousel, co vsechno se da s VESA
strankovanim udelat. Rychlost nevypada spatne.
Program bezi v rozliseni 800x600, odzkouseno na 166 MHz (doporuceno jako
minimalni konfigurace).
Datovy soubor obsahuje jeden obrazek formule v zakladni poloze (40x40 pixelu),
12 obrazku pozadi (50x50 pixelu) - pisek, palmy, silnice apod. a obrazek s
textem Generuji bitmapy atd. (vychazi mensi nez kdybych prilozil font),
vsechny komprimovane RLE kompresi.
Vsech 72 obrazku formule (po 5 stupnich) se generuje pomoci getpixelu
a maticove transformace souradnic. Urcite by se to dost zrychlilo, kdyby se
nasel nekdo, kdo by ty matice pronasobil rucne a pripadne jeste odstranil
realna cisla. Ted aspon muzu machrovat s nabihajici listou :-).}
uses VESA,grafika3,cas,klavesy,matyka;
const pozadi:array[0..30,0..30]of byte=
{delano ve velmi jednoduchem editoru, proto prosim omluvte chyby v navazovani
silnic (stejne povrch nema zadny vliv na jizdu)}
(($7,$7,$7,$7,$A,$7,$7,$7,$7,$8,$7,$7,$7,$7,$7,$7,$7,$B,$7,$7,$7,$7,$7,$9,$7,$7,$7,$9,$7,$7,$A),
($7,$A,$7,$7,$7,$7,$7,$7,$7,$7,$7,$7,$7,$7,$8,$7,$7,$8,$7,$7,$7,$7,$7,$B,$7,$7,$7,$7,$2,$3,$7),
($7,$7,$7,$9,$8,$7,$A,$A,$7,$8,$7,$9,$7,$7,$2,$2,$1,$1,$1,$1,$1,$1,$1,$1,$1,$1,$1,$1,$1,$4,$0),
($7,$B,$7,$7,$7,$8,$7,$7,$7,$7,$7,$7,$7,$7,$0,$7,$7,$7,$7,$7,$7,$7,$7,$7,$7,$7,$7,$7,$7,$0,$8),
($7,$7,$7,$7,$2,$3,$7,$7,$7,$8,$7,$7,$7,$A,$0,$7,$7,$7,$A,$7,$7,$8,$9,$2,$3,$7,$7,$8,$7,$0,$B),
($8,$7,$7,$7,$0,$5,$3,$B,$7,$7,$9,$7,$7,$7,$5,$1,$1,$1,$1,$1,$1,$1,$1,$4,$5,$1,$1,$1,$1,$4,$7),
($7,$7,$9,$7,$0,$A,$0,$7,$7,$8,$7,$7,$7,$9,$7,$7,$8,$7,$9,$7,$A,$7,$7,$7,$B,$7,$7,$7,$8,$7,$9),
($2,$1,$1,$1,$4,$8,$0,$7,$7,$7,$7,$B,$7,$7,$7,$9,$7,$7,$9,$7,$8,$7,$7,$7,$8,$7,$9,$2,$1,$1,$1),
($0,$B,$7,$A,$9,$8,$0,$7,$A,$B,$7,$7,$7,$7,$7,$7,$8,$9,$7,$8,$7,$B,$7,$2,$1,$1,$1,$4,$7,$7,$7),
($5,$1,$1,$1,$1,$1,$6,$1,$1,$1,$1,$1,$3,$7,$2,$1,$1,$3,$7,$A,$7,$7,$5,$3,$7,$2,$1,$1,$1,$4,$B),
($7,$B,$7,$7,$7,$7,$0,$7,$A,$A,$A,$7,$0,$7,$0,$8,$9,$5,$1,$1,$1,$1,$1,$4,$7,$0,$A,$7,$7,$7,$8),
($2,$3,$2,$1,$1,$1,$6,$1,$1,$1,$1,$1,$4,$7,$5,$3,$2,$1,$1,$1,$1,$1,$1,$1,$1,$4,$7,$B,$7,$9,$7),
($5,$6,$6,$3,$7,$7,$0,$7,$8,$7,$7,$9,$8,$7,$7,$5,$4,$7,$A,$7,$7,$7,$B,$B,$8,$9,$7,$9,$8,$7,$7),
($B,$5,$4,$5,$1,$1,$4,$7,$7,$B,$7,$7,$7,$A,$7,$B,$7,$7,$7,$7,$B,$8,$9,$8,$8,$7,$9,$7,$A,$7,$7),
($7,$8,$7,$7,$2,$1,$1,$1,$1,$1,$1,$1,$1,$1,$1,$1,$1,$3,$7,$7,$7,$2,$1,$1,$1,$1,$1,$3,$7,$B,$7),
($8,$2,$1,$1,$4,$9,$7,$8,$7,$9,$7,$7,$A,$7,$8,$7,$2,$4,$7,$7,$7,$0,$7,$8,$8,$9,$7,$0,$0,$0,$9),
($A,$5,$1,$1,$1,$1,$1,$3,$6,$7,$8,$7,$2,$0,$1,$1,$4,$7,$7,$7,$7,$1,$7,$7,$7,$7,$7,$0,$7,$7,$A),
($9,$7,$2,$0,$1,$1,$1,$4,$0,$7,$7,$7,$0,$7,$7,$8,$7,$9,$9,$7,$7,$0,$7,$7,$2,$1,$1,$4,$B,$8,$9),
($2,$1,$4,$5,$1,$1,$1,$1,$4,$7,$7,$7,$5,$3,$8,$7,$A,$7,$7,$B,$8,$5,$1,$1,$4,$7,$B,$7,$7,$9,$8),
($5,$1,$1,$1,$1,$1,$1,$1,$1,$1,$1,$1,$1,$4,$9,$7,$7,$8,$8,$9,$7,$A,$7,$A,$7,$B,$7,$7,$8,$7,$7),
($8,$7,$7,$B,$7,$7,$7,$7,$7,$A,$7,$9,$9,$7,$8,$7,$9,$9,$7,$8,$9,$7,$7,$B,$7,$9,$7,$7,$8,$8,$7),
($2,$1,$1,$1,$1,$1,$1,$1,$1,$1,$1,$1,$1,$1,$1,$1,$3,$7,$7,$1,$2,$1,$1,$1,$1,$1,$1,$1,$3,$7,$7),
($0,$7,$B,$7,$7,$7,$A,$7,$7,$7,$8,$7,$9,$B,$7,$7,$0,$7,$8,$7,$0,$7,$2,$0,$1,$1,$1,$1,$4,$8,$9),
($0,$7,$7,$8,$7,$7,$9,$7,$9,$7,$7,$8,$7,$9,$7,$7,$0,$7,$7,$7,$0,$7,$0,$7,$7,$9,$7,$A,$7,$7,$7),
($0,$7,$B,$7,$7,$7,$7,$7,$A,$9,$9,$7,$7,$8,$7,$9,$7,$5,$1,$1,$1,$6,$1,$6,$1,$1,$1,$3,$8,$7,$7),
($0,$7,$8,$7,$8,$7,$7,$7,$9,$7,$8,$7,$9,$7,$8,$7,$9,$7,$8,$9,$7,$0,$7,$0,$B,$7,$A,$0,$9,$9,$8),
($0,$7,$7,$7,$8,$7,$A,$7,$B,$7,$8,$7,$9,$7,$7,$8,$7,$9,$7,$8,$0,$7,$0,$8,$9,$8,$0,$7,$B,$B,$7),
($5,$3,$7,$7,$7,$2,$1,$1,$1,$1,$3,$7,$7,$7,$7,$2,$0,$1,$1,$1,$6,$1,$6,$1,$1,$1,$4,$A,$7,$8,$7),
($2,$4,$7,$A,$A,$8,$5,$3,$B,$9,$7,$0,$8,$7,$A,$A,$0,$7,$7,$7,$7,$0,$7,$0,$B,$7,$9,$7,$8,$9,$7),
($5,$1,$1,$1,$1,$1,$4,$7,$7,$A,$5,$6,$1,$1,$1,$4,$7,$7,$7,$7,$5,$1,$4,$A,$8,$9,$7,$9,$8,$7,$7),
($8,$7,$9,$9,$7,$8,$7,$9,$7,$8,$7,$B,$7,$9,$8,$7,$7,$A,$7,$9,$7,$8,$7,$7,$8,$7,$7,$B,$7,$8,$7));

dk=70;{cekani za kazdym cyklem v ms}

type pompolet=array[0..39,0..39]of byte;
     uknapp=^pompolet;

var obr:tobrazky;{nakonec tu budou obrazky pozadi}
    i,j,x,y,uhel,rychlost:integer;
    xs,ys,sf,cf:real;
    auto:array[0..71] of uknapp;{obrazky auta}
    Tpom,T12:matice3x3;  r,rv:vektor3; {pro transformace souradnic}
    f:file;
    cekatb,mazatb,keydown:boolean;

BEGIN
cekatb:=true; mazatb:=false; keydown:=false;
_setmode(_800x600);
if _pujdestrankovani then
 begin
 assign(f,'formule.dat');
 reset(f,1);
 nactiobrazky(obr,f);
 _putimage(10,500,400,9,obr.data^[0]);{napis "cekejte prosim"}
 zrusobrazky(obr);
 _rectangle(9,529,721,551,15);
 nactiobrazky(obr,f);
 _putimage(100,100,40,40,obr.data^[0]);{obrazek formule, ze ktereho budu nacitat ostatni}
 zrusobrazky(obr);
 {generovani otocenych obrazku formule:}
 for i:=0 to 71 do begin
                   _bar(10,530,10*i+10,550,2);{lista}
                   new(auto[i]);
                   {dosti prasacka transformace souradnic pixelu:}
                   cf:=rychlycos(5*i+180)/10000;
                   sf:=rychlysin(5*i+180)/10000;
                   for y:=0 to 39 do
                    for x:=0 to 39 do begin
                                      zadejmatici3x3(T12,1,0,120,
                                                         0,1,120,
                                                         0,0,1);
                                      zadejmatici3x3(Tpom,cf,-sf,0,
                                                          sf,cf,0,
                                                          0,0,1);
                                      soucinmatic3x3(T12,Tpom,T12);
                                      zadejmatici3x3(Tpom,1,0,-20,
                                                          0,1,-20,
                                                          0,0,1);
                                      soucinmatic3x3(T12,Tpom,T12);
                                      zadejvektor3(r,x,y,1);
                                      maticexvektor3(T12,r,rv);
                                      auto[i]^[x,y]:=_getpixel(round(rv[1]),round(rv[2]));
                                      end;
                   _putimage(640,100,40,40,auto[i]);
                   end;
 nactiobrazky(obr,f);{obrazky pro pozadi}
 close(f);
  _nastavstrankovani(true);
 xs:=1000; ys:=1000; rychlost:=0; uhel:=270;
 initklav;
  repeat   {hlavni cyklus}
  if cekatb then startcekani;
  {klavesnice:}
  if pressed[phsipka] and (rychlost<200) then inc(rychlost,8);
  if pressed[pdsipka] and (rychlost>-30) then dec(rychlost,8);
  if pressed[plsipka] then dec(uhel,5);
  if pressed[ppsipka] then inc(uhel,5);
  while uhel<0 do inc(uhel,360);
  while uhel>=360 do dec(uhel,360);
  if keydown then begin{cekani na uvolneni klaves}
                  if not (pressed[pmk] or pressed[pck]) then keydown:=false;
                  end
             else begin
                  if pressed[pmk] then begin
                                       mazatb:=not mazatb;
                                       keydown:=true;
                                       end;
                  if pressed[pck] then begin
                                       cekatb:=not cekatb;
                                       if cekatb then startcekani else stopcekani;
                                       keydown:=true;
                                       end;
                  end;
  {pohyb auta:}
  xs:=xs+(rychlost/10)*(rychlycos(uhel)/10000);
  ys:=ys+(rychlost/10)*(rychlysin(uhel)/10000);
  if xs<0 then xs:=0;
  if ys<25 then ys:=25;
  if xs>31*50-30 then xs:=31*50-30;
  if ys>31*50-30 then ys:=31*50-30;
  x:=round(xs); y:=round(ys);
  {vykresleni pozadi:}
  if mazatb then _fill2(0);
  for i:=0 to 30 do
   for j:=0 to 30 do _putimage(400-x+50*j,300-y+50*i,50,50,obr.data^[pozadi[i,j]]);
  {vykresleni auta:}
  _puttimage(400,300,40,40,auto[uhel div 5]);
  {diagnosticka lista vlevo nahore - melo by byt videt aspon trochu zelene:}
  if cekatb then begin _hline(0,dk,0,10); _hline(0,getms,0,12); end;
  _swap; {zobraz vsechno}
  if cekatb then pockej(dk);
  until pressed[1];
 {vypnuti vseho:}
 _nastavstrankovani(false);
 vratklav;
 zrusobrazky(obr);
 for i:=0 to 71 do dispose(auto[i]);
 _setmode(_textak);
 end
else
 begin
 _setmode(_textak);
 writeln('Bohuzel, na tohle nema vase grafarna dost pameti.');
 readln;
 end;
END.